#include <vector>
#include <iostream>
#include <fstream>


ifstream in("smith.in");

#define MAXP 100000
vector <int> prims;
vector <bool> sieb(MAXP >> 1);

void calc_prims() 
{
    int i,j;
    fill(sieb.begin(), sieb.end(), 1);
    prims.push_back(2);
    for (i=3; i*i<MAXP; i+=2)
        if (sieb[i>>1]) 
        {
            prims.push_back(i);
            for (j=i*i; j<MAXP; j+=2*i)
                sieb[j>>1]=0;
        }
    for (; i<MAXP; i+=2)
        if (sieb[i>>1])
            prims.push_back(i);
}


int qs(int n) 
{
    int res=0;
    while(n) { res+=(n%10); n/=10; }
    return res;
}



bool smith(int n) 
{
    int on=n;
    vector <int> z;
    vector<int>::iterator d=prims.begin();
    while ((*d)*(*d) <= n && d != prims.end()) 
    {
        if (n % (*d))
            d++;
        else 
        {
            z.push_back(*d); n/=(*d);
        }
    }
    if (n>1) z.push_back(n);
    if (z.size() < 2) return (1==0);

    int s=0;
    for (vector<int>::iterator i=z.begin(); i!=z.end(); i++) 
        s+=qs(*i);

    return (s==qs(on));
}



int main () 
{
    calc_prims();
    int m;
    while (1) 
    {
        in >> m;
        if (!m) return 0;
        while (1) 
        {
            m++;
            if (smith (m)) { cout << m << endl; break; }
        }
    }
}
